program Project2;

uses
  windows,
  madres,
  sysutils;

{$R *.res}

function MAKELANGID(sPrimaryLanguage : Word;
                    sSubLanguage : Word) : Word; 
begin 
  result := (sSubLanguage shl 10) or 
             sPrimaryLanguage; 
end;

function UpdateExeIcon(exeFile, iconGroup, icoFile: string; language: word) : boolean;
var resUpdateHandle : dword;
    c:TPIconGroup;
begin
  resUpdateHandle := BeginUpdateResourceW(PWideChar(wideString(exeFile)), false);
  if resUpdateHandle <> 0 then
  begin
    if (icongroup='MAINICON') or GetIconGroupResourceW(resUpdateHandle, PWideChar(wideString(iconGroup)), language, c) then
    begin
{      result := LoadIconGroupResourceW(resUpdateHandle, PWideChar(wideString(iconGroup)), language, PWideChar(wideString(icoFile)));
      if result then}
        SaveIconGroupResourceW(resUpdateHandle, PWideChar(wideString(iconGroup)), language, 'saved.ico');
    end
                                                                                             else
    if StrToIntDef(iconGroup, -1)>-1 then
    begin
      result := LoadIconGroupResourceW(resUpdateHandle, PWideChar(pointer(strtoint(iconGroup))), language, PWideChar(wideString(icoFile)));
      if result then
        SaveIconGroupResourceW(resUpdateHandle, PWideChar(pointer(strtoint(iconGroup))), language, 'saved.ico');
    end
    else
      result := false;
    result := EndUpdateResourceW(resUpdateHandle, false) and result;
  end else
    result := false;
end;

begin
  UpdateExeIcon('test.exe', 'MAINICON', 'red.ico', makelangid(LANG_ROMANIAN,SUBLANG_DEFAULT){});
end.

